/* GCC */
#include <fstream>
#include <iostream>
#include <iomanip>
#include <cmath>
#include <string>
#include <algorithm>

using namespace std;
const char base = 10;

string operator*(string str, char num)
{
    reverse(str.begin(), str.end());
    char carry(0);
    for(size_t i = 0; i < str.size(); ++i)
        (str[i] *= num) += carry, carry = str[i]/base, str[i] -= carry*base;
    if(carry)
        str.push_back(carry);
    reverse(str.begin(), str.end());
    return str;
}

void plus_equal(string& str, char num)
{
    reverse(str.begin(), str.end());
    char carry(0);
    str[0] += num;
    carry = str[0]/base;
    size_t i(1);
    while(carry && i != str.size())
        str[i] += carry, carry = str[i]/base, ++i;
    if(carry)
        str.push_back(carry);
    reverse(str.begin(), str.end());
}

bool operator <=(const string& s1, const string& s2)
{
    if(s1.size() > s2.size())
        return false;
    else if(s2.size() > s1.size())
        return true;
    else
        for(size_t i = 0; i < s1.size(); ++i)
            if(s1[i] > s2[i])
                return false;
    return true;
}

string& operator-=(string& s1, string s2)
{
    reverse(s1.begin(), s1.end());
    reverse(s2.begin(), s2.end());
    char carry(0);
    size_t i(0);
    for(; i < s2.size(); ++i)
    {
        s1[i] -= (s2[i] + carry);
        if(s1[i] < 0)
            s1[i] += base, carry = 1;
        else
            carry = 0;
    }
    while(carry)
    {
        --s1[i];
        if(s1[i] < 0)
            s1[i] += base, carry = 1;
        else
            carry = 0;
    }
    while(!s1.empty() && s1.at(s1.size()-1) == 0)
        s1.erase(s1.size()-1, 1);
    reverse(s1.begin(), s1.end());
    return s1;
}

int main(void)
{
    string str, rt, tmp;
    size_t n, dotpos, after_first;
    ifstream in("root.in");
    in >> str >> n;
    dotpos = str.size();
    for(size_t i = 0; i < str.size(); ++i)
    {
        if(str[i] == '.')
            dotpos = i;
        str[i] -= '0';
    }
    if(dotpos&1)
        after_first = 1;
    else
        after_first = 2;
    if((str.size()-dotpos-1)&1)
        str.push_back(0);
    if((str.size()-dotpos-1)/2 < n)
        for(size_t i = 0; i < n-((str.size()-dotpos-1)/2); ++i)
        {
            str.push_back(0);
            str.push_back(0);
        }
    // first
    tmp.push_back(str[0]);
    if(after_first == 2)
        tmp.push_back(str[1]);
    string left(1, 0);
    while(left*left.at(left.size()-1) <= tmp)
        ++left[(left.size()-1)];
    --left[(left.size()-1)];
    tmp -= left*left.at(left.size()-1);
    rt.push_back(left.at(left.size()-1));
    plus_equal(left, rt.at(rt.size()-1));
    // after first
    for(size_t i = after_first; i != dotpos; i += 2)
    {
        tmp.push_back(str[i]); tmp.push_back(str[i+1]);
        left.push_back(0);
        while(left*left.at(left.size()-1) <= tmp)
            ++left[left.size()-1];
        --left[left.size()-1];
        tmp -= left*left.at(left.size()-1);
        rt.push_back(left.at(left.size()-1));
        plus_equal(left, rt.at(rt.size()-1));
    }
    rt.push_back('.'-'0');
    for(size_t i = dotpos+1; i < str.size(); i += 2)
    {
        tmp.push_back(str[i]); tmp.push_back(str[i+1]);
        left.push_back(0);
        while(left*left.at(left.size()-1) <= tmp)
            ++left[left.size()-1];
        --left[left.size()-1];
        tmp -= left*left.at(left.size()-1);
        rt.push_back(left.at(left.size()-1));
        plus_equal(left, rt.at(rt.size()-1));
    }
    for(size_t i = 0; i < rt.size(); ++i)
        rt[i] += '0';
    ofstream out("root.out");
    out << rt << '\n';
    out.close();
    return 0;
}
