/* GCC */
#include <fstream>
#include <iomanip>
#include <cmath>
#include <vector>

using namespace std;
const size_t base = 10000;
vector<size_t> ans;
size_t to[15501], m[15501] = {}, n, carry, next, cur, mul(1), cnt;
bool used[15501] = {};

void multiply(size_t num)
{
    carry = 0;
    for(size_t i = 0; i < n; ++i)
        (ans[i] *= num) += carry, carry = ans[i]/base, ans[i] -= carry*base;
    if(carry)
        ans.push_back(carry);
}

int main()
{
    ios_base::sync_with_stdio(false);
    ans.push_back(1);
    ans.reserve(250);
    ifstream in("sleep.in");
    in >> n;
    for(size_t i = 1; i <= n; ++i)
        in >> to[i];
    in.close();
    for(size_t i = 1; i <= n; ++i)
        if(!used[i])
        {
            used[i] = true, next = to[i], cur = 1;
            while(!used[next])
                used[next]= true, next = to[next], ++cur;
            for(size_t j = 2; j <= sqrt(cur); ++j)
                if(cur % j == 0)
                {
                    cur /= j, cnt = 1;
                    while(cur % j == 0)
                        cur /= j, ++cnt;
                    if(m[j] < cur)
                        m[j] = cur;
                }
            if(cur != 1 && m[cur] == 0)
                m[cur] = 1;
        }
    for(size_t i = 2; i <= n; ++i)
    {
        while(m[i])
        {
            --m[i];
            if(mul * i < base)
                mul *= i;
            else
            {
                multiply(mul);
                mul = i;
            }
        }
    }
    if(mul != 1)
        multiply(mul);
    ofstream out("sleep.out");
    out << ans.back() << setfill('0');
    for(size_t i = ans.size()-2; i != 0xffffffff; --i)
        out << setw(4) << ans[i];
    out << '\n';
    out.close();
    return 0;
}
