/* GCC */

#include <fstream>
#include <vector>
#include <algorithm>
#include <cstdio>
#include <cstring>
using namespace std;

#define NAME "sleep"

void read_g(vector <vector <bool> >& g, int& n)
{
    ifstream fin(NAME ".in");

    fin >> n;
    for (int i = 0; i < n; ++i)
    {
        g.push_back(vector<bool> (n, false));
        int t;
        fin >> t;
        g[i][t-1] = true;
    }

    fin.close();
}

void dfs(const vector <vector <bool> >& g, vector <bool>& visited, vector<unsigned long long>& cycles, int start, int k)
{
    visited[start] = true;
    for (int i = 0; i < g.size(); ++i)
    {
        if (g[start][i])
        {
            if (!visited[i])
            {
                //cout << start << " -> " << i << endl;
                dfs(g, visited, cycles, i, k+1);
            }
            else
                cycles.push_back(k+1);

        }
    }
}

void get_cycles(const vector <vector <bool> >& g, vector<unsigned long long>& cycles)
{
    vector <bool > visited(g.size(), false);
    for (int i =0; i < g.size(); ++i)
    {
        if (!visited[i])
            dfs(g, visited, cycles, i, 0);
    }

}

unsigned long long euclid(unsigned long long a, unsigned long long b)
{
    if ( a == 0)
        return b;
    else
        return euclid(b % a, a);
}

class Longint
{
private:
    vector <short> d;
public:
    Longint(int n)
    {
        char s[20];
        sprintf(s, "%d", n);
        for (int i = strlen(s) - 1; i >= 0; --i)
            d.push_back(s[i] - '0');
    }
    friend Longint operator*(const Longint& a, const Longint& b)
    {
        Longint c(0);
        for (int i = 0;i < b.d.size(); ++i)
        {
            Longint sum(0);
            sum.d.clear();
            for (int j = 0; j < i; ++j)
                sum.d.push_back(0);
            int off = 0;
            for (int j = 0; j < a.d.size(); ++j)
            {
                int s = (a.d[j] * b.d[i] + off);
                sum.d.push_back(s % 10);
                off = s / 10;
            }
            if (off > 0)
                sum.d.push_back(off);
            //cout << i << ": " << sum << endl;
            c = c + sum;
        }
        return c;
    }
    friend Longint operator+(const Longint& a, const Longint& b)
    {
        Longint c(0);
        const Longint* p;
        int n = min(a.d.size(), b.d.size());
        if (a.d.size() > b.d.size())
        {
             c = a;
             p = &b;
        }
        else
        {
            c = b;
            p = &a;
        }
        int off = 0;
        for (int i = 0; i < c.d.size(); ++i)
        {
            if (i < n)
            {
                int s = (c.d[i] + p->d[i] + off);
                c.d[i] = s % 10;
                off = s / 10;
            }
            else
            {
                int s = (c.d[i] + off);
                c.d[i] = s % 10;
                off = s / 10;
            }

        }
        if (off > 0)
            c.d.push_back(off);
        return c;

    }
    friend ostream& operator<<(ostream& o, const Longint& a)
    {
        for (int i = a.d.size() - 1; i >= 0; --i)
            o << a.d[i];
        return o;
    }
};

vector<unsigned long long> get_mul(unsigned long long t)
{
    vector<unsigned long long> v;
    unsigned long long i = 2;
    while (t != 1)
    {
        if (t % i == 0)
        {
            t /= i;
            v.push_back(i);
        }
        else
            ++i;
    }
    return v;
}

int main()
{

    int n;

    vector <vector <bool> > g;
    read_g(g, n);



    vector <unsigned long long> cycles;

    get_cycles(g,cycles);
    //int ar[] = {6, 7, 2, 3, 4, 5};
    //cycles = vector<unsigned long long>(ar, ar+ 6);


    unsigned long long t;

    for (int i = 0; i < cycles.size(); ++i)
        for (int j = i+1; j < cycles.size(); ++j)
            if ((t = euclid(cycles[i], cycles[j])) != 1)
            {
                vector<unsigned long long> v = get_mul(t);
                for (int z = 0; z < v.size(); ++z)
                    if (cycles[i] % v[z] == 0)
                        cycles[i] /= v[z];
                    else
                        cycles[j] /= v[z];

            }

    Longint ans(1);
    for (int i = 0; i < cycles.size(); ++i)
    {
        Longint t(cycles[i]);
        ans = ans * t;
    }

    ofstream fout(NAME ".out");
    fout << ans << endl;

    fout.close();
    return 0;
}
